Add-Type -assembly System.Windows.Forms

$main_form = New-Object System.Windows.Forms.Form

$main_form.Text = "ogibiotec - OGI 3 - BR4.1.3"
$main_form.Width = 600
$main_form.Height = 400

$Label = New-Object System.Windows.Forms.Label
$Label.Text = "Select COM port"
#
# Set font family name and size
$Label.Font = 'Courier New,14'

# Set element position based on pixels from left and top of form
$Label.Location = New-Object System.Drawing.Point(0,10)
$Label.AutoSize = $true
$main_form.Controls.Add($Label)


$ComboBox = New-Object System.Windows.Forms.ComboBox
$ComboBox.Width = 300
$ComboBox.Location = New-Object System.Drawing.Point(190,10)
$main_form.Controls.Add($ComboBox)

$ComboBox.Items.Clear()
$portobjs = Get-CimInstance Win32_SerialPort | Select-Object -Property Name # List Serial ports

Foreach ($portobj in $portobjs)
{
  $ComboBox.Items.Add($portobj.Name);
}

$RefreshButton = New-Object System.Windows.Forms.Button
$RefreshButton.Location = New-Object System.Drawing.Point(500,10)
$RefreshButton.Size = New-Object System.Drawing.Size(80,23)
$RefreshButton.Text = "Refresh"
$main_form.Controls.Add($RefreshButton)

$RefreshButton.Add_Click({
  $ComboBox.Items.Clear()
  $portobjs = Get-CimInstance Win32_SerialPort | Select-Object -Property Name # List Serial ports

  Foreach ($portobj in $portobjs)
  {
    $ComboBox.Items.Add($portobj.Name);
  }
})

$Output = New-Object System.Windows.Forms.TextBox
$Output.Font = 'Courier New,10'
$Output.Location = New-Object System.Drawing.Point(10,50)
$Output.Size = New-Object System.Drawing.Size(500,240)
$Output.multiline = $true
$Output.Scrollbars = "Vertical"
$main_form.Controls.Add($Output)

$Button = New-Object System.Windows.Forms.Button
$Button.Location = New-Object System.Drawing.Point(10,300)
$Button.Size = New-Object System.Drawing.Size(120,23)
$Button.Text = "Upload"
$main_form.Controls.Add($Button)

$Button.Add_Click(
  {
  $Button.Text = "Uploading"
  $Job = Start-ThreadJob {
    if (-not ($Using:ComboBox).selectedItem) {
      ($Using:Output).AppendText("No port selected `n")
      Return
    }

    $portfound = ($Using:ComboBox).selectedItem -match "COM[0-9]*"
    $portname = $Matches.Values

    $port = New-Object System.IO.Ports.SerialPort $portname,1200,None,8,one               # Establish connection
    try {
      $port.open()
      $port.close()
    }
    catch {
      ($Using:Output).AppendText("Failed!")
    }


    .\bin\bossac -i -d --port=$portname -U false -e -w -v -b .\bin\*.ino.bin -R 2>&1 |
    Select-String -CaseSensitive "No device.*|Erase.*|done.*|Write.*|Verify.*|CPU.*|\[.+pages\)" |  # Print progress & useful info
    foreach {$_.Matches.Value | Out-String}
  }

  While ($Job.State -ne "Completed") {
    Start-Sleep -Seconds 1

    $txt = Receive-Job -Job $Job
    $Output.AppendText($txt)
  }
  $Button.Text = "Upload"
  }
)

$main_form.ShowDialog()

